//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers  1
#property indicator_color1   PaleVioletRed
#property indicator_color3   Silver
#property indicator_width1   2
#property indicator_minimum -1.0
#property indicator_maximum  101

//
//
//
//
//

extern string UseSymbol = "";
extern int    RsiPeriod = 14;
extern int    RsiPrice  = PRICE_CLOSE;

//
//
//
//
//

double rsi[];
string indicatorFileName;
bool   returnBars;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,rsi);
         indicatorFileName = WindowExpertName();
         returnBars        = (UseSymbol=="returnBars");  if (returnBars) return(0);
         if (UseSymbol == "") UseSymbol = Symbol();
   IndicatorShortName(UseSymbol+" RSI ("+RsiPeriod+")");
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int countedBars = IndicatorCounted();
      if (countedBars<0) return(-1);
      if (countedBars>0) countedBars--;
         int limit = MathMin(Bars-countedBars,Bars-1);
            if (returnBars) { rsi[0] = MathMin(limit+1,Bars-1); return(0); }
            if (UseSymbol!=Symbol()) limit = MathMax(limit,MathMin(Bars-1,iCustom(UseSymbol,0,indicatorFileName,"returnBars",0,0)));
   
   //
   //
   //
   //
   //
   
      for(int i=limit; i >= 0; i--)
      {
         int y = iBarShift(UseSymbol,0,Time[i]); rsi[i] = iRSI(UseSymbol,0,RsiPeriod,RsiPrice,y);
      }
   return(0);
}